// shell access excecuted in a Java thread
// created by Zachary Seldess, 01/01/11, revised 02/03/12
// Visualization Lab, King Abdullah University of Science and Technology
// Copyright  2012 King Abdullah University of Science and Technology. Some Rights Reserved.

import java.io.*;
import com.cycling74.max.*;

public class shellAccess extends MaxObject {
	private ShellThread p;
	private Process pr;	
	private boolean prRunning = false;
	
	private class ShellThread extends Thread {
		private String[] parameter;
		private Runtime run = Runtime.getRuntime();
		private String line = null;
		private BufferedReader buf;
		private OutputStreamWriter out;
		
		public ShellThread(String[] s) {
			parameter = s;
		}

		public void run() {				 
			try {
				pr = run.exec(parameter);
				//pr.waitFor();
				prRunning = true;

				buf = new BufferedReader(new InputStreamReader(pr.getInputStream()));
				out = new OutputStreamWriter(pr.getOutputStream());
				line = buf.readLine();
				while (line != null) {
					output(0, line);
					line = buf.readLine();
				}
				
				buf.close();
				out.close();
				prRunning = false;
				output(1, "bang"); // bang out right outlet when process complete
			}
			catch (Exception e) {
				maxPost(e);
				prRunning = false;
			}		
		}
		
		public void cmdToProcess(String s) {
			//post("cmdToProcess" + s);
			String newline = System.getProperty("line.separator"); // ensures newline works cross-platform
			try {			
				out.write(s);
				out.write(newline);
				out.flush();
			}
			catch (Exception e) {
				maxPost(e);
			}
		}					
	}
		
	shellAccess() {
		declareIO(1,2);
		setInletAssist(0, "Send incoming command to shell");
		setOutletAssist(0, "Shell standard output stream");
		setOutletAssist(1, "Bang when process finished");		
		createInfoOutlet(false);
		post("shellAccess by Zachary Seldess. Build Feb 3 2012.");
		post("Copyright  2012 King Abdullah University of Science and Technology. Some Rights Reserved.");
	}
	
	public void anything(String msg, Atom[] args) {	

		if (msg.equals("destroy")) {
			if (prRunning) {
				pr.destroy();
				//post("process killed");
			}
			else {
				//post("no process to kill");
			}
		}
		else if (!prRunning) {
			String[] cmd = new String[args.length+1]; // set String[] to length of incoming message
			cmd[0] = msg;
			for (int i = 1; i < cmd.length; i++) {
				cmd[i] = args[i-1].toString(); // store each element in new String array
			}
			//outlet(0, cmd);
			runThread(cmd);
		}
		else {
			String cmd = msg; // start building cmd string
			for (int i = 0; i < args.length; i++) {
				cmd = cmd + " " + args[i].toString(); // append args to end of cmd string
			}
			//outlet(0, cmd);
			cmdToThread(cmd);
		}			
	}

	private void output(int i, String s) {
		outlet(i, s);
	}

	private void maxPost(Exception e) {
		post("shellAccess: " + e);
	}

	private void runThread(String[] s) {
		p = new ShellThread(s);
		p.start();
	}
	
	private void cmdToThread(String s) {
		p.cmdToProcess(s);
	}
}
































